<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Parsers/Cpp/__init__.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Parsers/Cpp/__init__.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Parsers/Cpp/__init__.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2003 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-string">&quot;&quot;&quot;Preprocessor for C, C++, IDL&quot;&quot;&quot;</span></span>
<a id="line9"></a><span class="lineno"> 9</span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">from</span> Emulator <span class="py-keyword">import</span> get_compiler_info</span>
<a id="line12"></a><span class="lineno">12</span><span class="line"><span class="py-keyword">from</span> ParserImpl <span class="py-keyword">import</span> parse</span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="py-keyword">import</span> os.path</span>
<a id="line14"></a><span class="lineno">14</span>
<a id="line15"></a><span class="lineno">15</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Cpp/Parser.html">Parser</a>(Processor):</span>
<a id="line16"></a><span class="lineno">16</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">    emulate_compiler = Parameter(<span class="py-string">''</span>, <span class="py-string">'a compiler to emulate'</span>)</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">    compiler_flags = Parameter([], <span class="py-string">'list of flags for the emulated compiler'</span>)</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">    flags = Parameter([], <span class="py-string">'list of preprocessor flags such as -I or -D'</span>)</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">    primary_file_only = Parameter(True, <span class="py-string">'should only primary file be processed'</span>)</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">    cpp_output = Parameter(None, <span class="py-string">'filename for preprocessed file'</span>)</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">    base_path = Parameter(None, <span class="py-string">'path prefix to strip off of the filenames'</span>)</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">    language = Parameter(<span class="py-string">'C++'</span>, <span class="py-string">'source code programming language of the given input file'</span>)</span>
<a id="line24"></a><span class="lineno">24</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Cpp/Parser.html#probe">probe</a>(self, **kwds):</span>
<a id="line26"></a><span class="lineno">26</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">        <span class="py-keyword">if</span> type(self.compiler_flags) != list:</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">            <span class="py-keyword">raise</span> InvalidArgument(<span class="py-string">'compiler_flags=%s (expected list)'</span>%repr(self.compiler_flags))</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">        <span class="py-keyword">return</span> get_compiler_info(self.language,</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">                                 self.emulate_compiler,</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">                                 self.compiler_flags)</span>
<a id="line33"></a><span class="lineno">33</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Cpp/Cpp/Parser.html#process">process</a>(self, ir, **kwds):</span>
<a id="line35"></a><span class="lineno">35</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.input: <span class="py-keyword">raise</span> MissingArgument(<span class="py-string">'input'</span>)</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        self.ir = ir</span>
<a id="line39"></a><span class="lineno">39</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">        system_flags = []</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        <span class="py-comment"># Accept either a string or a list.</span></span>
<a id="line42"></a><span class="lineno">42</span><span class="line">        flags = type(self.flags) <span class="py-keyword">is</span> str <span class="py-keyword">and</span> self.flags.split() <span class="py-keyword">or</span> self.flags</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">        base_path = self.base_path <span class="py-keyword">and</span> os.path.abspath(self.base_path) + os.sep <span class="py-keyword">or</span> <span class="py-string">''</span></span>
<a id="line44"></a><span class="lineno">44</span><span class="line">        info = get_compiler_info(self.language,</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">                                 self.emulate_compiler,</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">                                 self.compiler_flags)</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">        system_flags += [<span class="py-string">'-I%s'</span>%x <span class="py-keyword">for</span> x <span class="py-keyword">in</span> info.include_paths]</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">        system_flags += [<span class="py-string">'-D%s'</span>%k + (v <span class="py-keyword">and</span> <span class="py-string">'=%s'</span>%v <span class="py-keyword">or</span> <span class="py-string">''</span>)</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">                         <span class="py-keyword">for</span> (k,v) <span class="py-keyword">in</span> info.macros]</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">        <span class="py-keyword">for</span> file <span class="py-keyword">in</span> self.input:</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">            self.ir = parse(self.ir,</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">                            os.path.abspath(file),</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">                            base_path,</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">                            self.cpp_output,</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">                            self.language, system_flags, flags,</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">                            self.primary_file_only,</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">                            self.verbose, self.debug, self.profile)</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">        <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line59"></a><span class="lineno">59</span>
<a id="line60"></a><span class="lineno">60</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
